<?php

/**
 * liquidaciones_debito_tit actions.
 *
 * @package    canon
 * @subpackage liquidaciones_debito_tit
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class liquidaciones_debito_titActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 300;
            }

            /*
             * variables de filtro
             */

            $idTitulo = ' ';
            if (isset($request['id_titulo'])) {
                $idTitulo = $request['id_titulo'];
            }

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            
            $query="select tab0.* from(
-- notas debito viejas
select 
eta.id_etapa,
tab0.id_titulo, eta.nombre as nombre_etapa, tab1.anualidad, 
to_char(tab1.fecha_inicio, 'YYYY-MM-DD') as fecha_inicio, to_char(tab1.fecha_fin, 'YYYY-MM-DD') as fecha_fin, 
tab1.liquidado,
tab5.id_debitos as id_debito, tab5.sec_debitos as sec_debito,
null as id_debito_old, null as sec_debito_old 
from ca_det_liq_canon tab0
join rmn_titulo tit on tab0.id_titulo=tit.id_titulo
join ca_anual_etapa tab1 on tab0.id_anual_etapa = tab1.id_anual_etapa
join ca_titulo_etapa tab2 on tab1.id_titulo_etapa=tab2.id_titulo_etapa
join ca_etapa eta on tab2.id_etapa = eta.id_etapa 
left join ca_recibo tab3 on tab0.id_det_liq_canon = tab3.id_det_liq_canon and tab0.vigencia = tab3.vig_liq  
left join ca_recibo_debito_v tab5 on tab3.id_recibo = tab5.id_recibo and tab3.vigencia = tab5.vigencia 
where tab0.id_titulo = '$idTitulo' 
and tab0.aprobado = '1' 
and tab0.anulado = '0' 


union

-- notas debito asignadas
select
tab2.id_etapa, 
tab0.id_titulo, tab2.nombre as nombre_etapa, tab1.anualidad, to_char(tab1.fecha_inicio, 'YYYY-MM-DD') as fecha_inicio, 
to_char(tab1.fecha_fin, 'YYYY-MM-DD') as fecha_fin,
tab1.liquidado, null as id_debito, null as sec_debito,
tab4.id_debito as id_debito_old, tab4.sec_debito as sec_debito_old 
from ca_titulo_etapa tab0 
join ca_anual_etapa tab1 on tab0.id_titulo_etapa = tab1.id_titulo_etapa
join ca_etapa tab2 on tab0.id_etapa = tab2.id_etapa  
left join ca_anual_etapa_deb_v tab4 on tab1.id_anual_etapa = tab4.id_anual_etapa  
where tab0.id_titulo = '$idTitulo' and tab0.actual=1 and tab1.liquidado=0
    
)tab0

order by tab0.id_etapa, tab0.fecha_inicio";
            
            $sql = <<<EOD
select count(*) as count from(
 
  $query

)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {

                /*
                 * Obtiene los accesos para un perfil
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
 $query       
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_liquidaciones_debito_tit');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                  //  $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }

                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[CA_LIQUIDACIONES_DEBITO_TIT] Consulta exitosa.");
            } else {

                $mensaje = "[CA_LIQUIDACIONES_DEBITO_TIT] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {
            $error="[CA_LIQUIDACIONES_DEBITO_TIT] ERROR: ". $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
